﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private splitMain As SplitPane
	Private splitRight As SplitPane
	Private lstViews As ListView
	Private Tree As CLVTree
	Private lstHistory As ListView
	Private CustomListView1 As CustomListView
	Private TextArea1 As TextArea
	Private WebView1 As WebView
	Private PnlProperties As B4XView
	'Private txtUrl As TextField
	Private PD1 As PreferencesDialog
	
	Private html As CLVTreeItem
	Private head As CLVTreeItem
	Private body As CLVTreeItem
	Private div1 As CLVTreeItem
	Private div2 As CLVTreeItem
	Private div3 As CLVTreeItem 'ignore
	Private form1 As CLVTreeItem
	Private form2 As CLVTreeItem 'ignore
	Private scr1 As CLVTreeItem 'ignore
	'Private meta1 As CLVTreeItem
	'Private meta2 As CLVTreeItem
	'Private title As CLVTreeItem
	'Private link1 As CLVTreeItem
	'Private heading1 As CLVTreeItem
	'Private div1 As CLVTreeItem
	'Private form1 As CLVTreeItem
	'Private div2 As CLVTreeItem
	'Private label1 As CLVTreeItem
	'Private input1 As CLVTreeItem
	'Private button1 As CLVTreeItem
	'Private div3 As CLVTreeItem
	Type HtmlElement(HtmlTag As Object, Attributes As List, Content As String)
	Type HtmlAttribute(Name As String, Value As Object)
	Private Source As String
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "Simple HTML Editor")
	splitMain.LoadLayout("LeftSide")
	splitMain.LoadLayout("Center")
	splitMain.LoadLayout("RightSide")
	'limit the widths of the two side layouts
	splitMain.SetSizeLimits(0, 0, 200)
	splitMain.SetSizeLimits(2, 0, 300)
	CreateRightSizeLayout
	LoadViewList
	GrowTree
	'lstViews.Items.AddAll(File.ReadList(File.DirAssets, "sites.txt"))
	'lstViews.SelectedIndex = 0
End Sub

Private Sub CreateRightSizeLayout
	splitRight.LoadLayout("RightProperties")
	splitRight.LoadLayout("RightMessageLog")
	'lstProperties.Items.Add("http://www.b4x.com")
End Sub

'Private Sub SplitRight_Resize (Width As Double, Height As Double)
'	PD1.mBase.Height = Height - 60dip
'End Sub

'Private Sub PnlProperties_Resize (Width As Double, Height As Double)
'	If PD1.IsInitialized Then 
'		PD1.Dialog.Resize(Width, Height)
'		PD1.Dialog.mParent.Top = 0
'	End If
'End Sub

Private Sub btnDesigner_Click
	CustomListView1.AsView.Visible = True
	TextArea1.Visible = False
	WebView1.Visible = False
End Sub

Private Sub btnCode_Click
	CustomListView1.AsView.Visible = False
	TextArea1.Visible = True
	WebView1.Visible = False
	TestOutput
	TextArea1.Text = Source' TreeToJson
End Sub

Private Sub btnPreview_Click
	CustomListView1.AsView.Visible = False
	TextArea1.Visible = False
	WebView1.Visible = True
	File.WriteString(File.DirApp, "index.html", Source)
	WebView1.LoadHtml(File.ReadString(File.DirApp, "index.html"))
End Sub

Private Sub LoadViewList
	lstViews.Items.Add("<div>")
	lstViews.Items.Add("<p>")
	lstViews.Items.Add("<span>")
	lstViews.Items.Add("<form>")
	lstViews.Items.Add("<label>")
	lstViews.Items.Add("<button>")
	lstViews.Items.Add($"<input type="text">"$)
	lstViews.Items.Add($"<input type="email">"$)
	lstViews.Items.Add($"<input type="password">"$)
	lstViews.Items.Add($"<input type="date">"$)
	lstViews.Items.Add("<select>")
	lstViews.Items.Add("<table>")
	lstViews.Items.Add("<th>")
	lstViews.Items.Add("<tbody>")
	lstViews.Items.Add("<tr>")
	lstViews.Items.Add("<td>")
End Sub

Private Sub GrowTree
	CustomListView1.DefaultTextBackgroundColor = xui.Color_White
	Tree.Initialize(CustomListView1)
	'logo = xui.LoadBitmap(File.DirAssets, "logo.png")
	Dim me1 As HtmlElement = CreateHtmlElement("<html>", Array(CreateHtmlAttribute("lang", "en")), "")
	Dim me2 As HtmlElement = CreateHtmlElement("<head>", Null, "")
	Dim me3 As HtmlElement = CreateHtmlElement("<body>", Null, "") 'ignore
	'Dim me4 As HtmlElement = CreateHtmlElement("<script>", Null, "") 'ignore
	Dim hc1 As HtmlElement = CreateHtmlElement("<meta>", Array(CreateHtmlAttribute("charset", "utf-8")), "")
	Dim hc2 As HtmlElement = CreateHtmlElement("<meta>", Array As Object(CreateHtmlAttribute("name", "viewport"), CreateHtmlAttribute("content", CreateMap("width": "device-width", "initial-scale": 1))), "")
	Dim hc3 As HtmlElement = CreateHtmlElement("<title>", Null, "Demo Website")
	Dim hc4a As List
	hc4a.Initialize
	hc4a.Add(CreateHtmlAttribute("rel", "stylesheet"))
	hc4a.Add(CreateHtmlAttribute("href", WebViewAssetFile("bootstrap.min.css")))
	'hc4a.Add(CreateHtmlAttribute("href", "https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css"))
	'hc4a.Add(CreateHtmlAttribute("integrity", "sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65"))
	'hc4a.Add(CreateHtmlAttribute("crossorigin", "anonymous"))
	Dim hc4 As HtmlElement = CreateHtmlElement("<link>", hc4a, "")
	Dim bc1 As HtmlElement = CreateHtmlElement("<h1>", Null, "Hello World!")
	Dim bc2 As HtmlElement = CreateHtmlElement("<div>", Array(CreateHtmlAttribute("class", "col-md-6")), "")
	Dim dc1 As HtmlElement = CreateHtmlElement("<form>", Array(CreateHtmlAttribute("id", "form1"), CreateHtmlAttribute("class", "login")), "")
	Dim fc1 As HtmlElement = CreateHtmlElement("<div>", Array(CreateHtmlAttribute("class", "mb-3")), "")
	Dim dc2 As HtmlElement = CreateHtmlElement("<label>", Array(CreateHtmlAttribute("for", "email"), CreateHtmlAttribute("class", "form-label")), "email")
	Dim dc3 As HtmlElement = CreateHtmlElement("<input>", Array(CreateHtmlAttribute("type", "email"), CreateHtmlAttribute("id", "email"), CreateHtmlAttribute("class", "form-control")), "")
	Dim fc2 As HtmlElement = CreateHtmlElement("<button>", Array(CreateHtmlAttribute("type", "submit"), CreateHtmlAttribute("id", "send"), CreateHtmlAttribute("class", "btn btn-primary")), "Submit")
	Dim bc3 As HtmlElement = CreateHtmlElement("<div>", Array(CreateHtmlAttribute("class", "col-md-6")), "")
	Dim bc4a As List
	bc4a.Initialize
	bc4a.Add(CreateHtmlAttribute("src", WebViewAssetFile("bootstrap.bundle.min.js")))
	'bc4a.Add(CreateHtmlAttribute("src", "https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js"))
	'bc4a.Add(CreateHtmlAttribute("integrity", "sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4"))
	'bc4a.Add(CreateHtmlAttribute("crossorigin", "anonymous"))
	Dim bc4 As HtmlElement = CreateHtmlElement("<script>", bc4a, "")
	
	Dim html As CLVTreeItem = Tree.AddItem(Tree.Root, me1.HtmlTag, Null, me1)
	Dim head As CLVTreeItem = Tree.AddItem(html, me2.HtmlTag, Null, me2)
	Dim body As CLVTreeItem = Tree.AddItem(html, me3.HtmlTag, Null, me3)
	Tree.AddItem(head, hc1.HtmlTag, Null, hc1)
	Tree.AddItem(head, hc2.HtmlTag, Null, hc2)
	Tree.AddItem(head, hc3.HtmlTag, Null, hc3)
	Tree.AddItem(head, hc4.HtmlTag, Null, hc4)
	Tree.AddItem(body, bc1.HtmlTag, Null, bc1)
	div1 = Tree.AddItem(body, bc2.HtmlTag, Null, bc2)
	form1 = Tree.AddItem(div1, dc1.HtmlTag, Null, dc1)
	div2 = Tree.AddItem(form1, fc1.HtmlTag, Null, fc1)
	Tree.AddItem(div2, dc2.HtmlTag, Null, dc2)
	Tree.AddItem(div2, dc3.HtmlTag, Null, dc3)
	Tree.AddItem(form1, fc2.HtmlTag, Null, fc2)
	div3 = Tree.AddItem(body, bc3.HtmlTag, Null, bc3)
	scr1 = Tree.AddItem(body, bc4.HtmlTag, Null, bc4)
End Sub

Sub TestOutput
	Source = "<!doctype html>"
	Dim MyList As List = TreeToList
	For Each Item In MyList
		Log(Item)
	Next
End Sub

Public Sub TreeToList As List
	Dim l As List
	l.Initialize
	TreeToItems(Tree.Root, l)
	Return l
End Sub

Private Sub TreeToItems (ParentTreeNode As CLVTreeItem, ParentList As List)
	For Each child As CLVTreeItem In ParentTreeNode.Children
		Dim m As Map = CreateMap() 'CreateMap("text": child.Text, "tag": child.Tag)
		Dim h As HtmlElement = child.Tag
		
		Dim OpenTag As String = h.HtmlTag.As(String)
		Dim CloseTag As String = OpenTag.Replace("<", "</")
		If h.Attributes.IsInitialized Then ' And h.Attributes.Size > 0 Then
			Dim Attributes As String
			For Each ha As HtmlAttribute In h.Attributes
				Dim newValue As String = ha.Value.As(String).Replace("{", "").Replace("}", "")
				Attributes = Attributes &  $" ${ha.Name}="${newValue}""$
			Next
			OpenTag = OpenTag.Replace(">", Attributes & ">")
		End If
		Source = Source & OpenTag
		
		If h.Content.Length > 0 Then Source = Source & h.Content
		
		ParentList.Add(m)
		If child.Children.IsInitialized And child.Children.Size > 0 Then
			Dim children As List
			children.Initialize
			m.Put("children", children)
			TreeToItems(child, children)
		End If
		Select CloseTag
			Case "</meta>", "</hr>", "</input>", "</img>", "</link>"
				' self closing tag
			Case Else
				Source = Source & CloseTag
		End Select
	Next
End Sub

Private Sub lstViews_MouseClicked (EventData As MouseEvent)
	Select EventData.ClickCount
		Case 2
			Select lstViews.SelectedItem
				Case "<div>"
					Dim bc As HtmlElement = CreateHtmlElement("<div>", Array(CreateHtmlAttribute("class", "col-md-6")), "")
					Tree.AddItem(body, bc.HtmlTag, Null, bc)
				Case "<p>"
					Dim bc As HtmlElement = CreateHtmlElement("<p>", Null, "&nbsp;")
					Tree.AddItem(body, bc.HtmlTag, Null, bc)
				Case "<h1>"
					Dim bc As HtmlElement = CreateHtmlElement("<h1>", Null, "&nbsp;")
					Tree.AddItem(body, bc.HtmlTag, Null, bc)
				Case "<span>"
					Dim bc As HtmlElement = CreateHtmlElement("<span>", Array(CreateHtmlAttribute("class", "text-decoration-underline")), "")
					Tree.AddItem(body, bc.HtmlTag, Null, bc)
				Case "<form>"
					Dim dc As HtmlElement = CreateHtmlElement("<form>", Array(CreateHtmlAttribute("id", "form1"), CreateHtmlAttribute("class", "form")), "")
					form2 = Tree.AddItem(div2, dc.HtmlTag, Null, dc)				
				Case $"<label>"$
					Dim dc As HtmlElement = CreateHtmlElement("<label>", Array(CreateHtmlAttribute("for", "username"), CreateHtmlAttribute("class", "form-label")), "username")
					Tree.AddItem(div2, dc.HtmlTag, Null, dc)
				Case $"<input type="text">"$
					Dim dc As HtmlElement = CreateHtmlElement("<input>", Array(CreateHtmlAttribute("type", "text"), CreateHtmlAttribute("id", "username"), CreateHtmlAttribute("class", "form-control")), "")
					Tree.AddItem(div2, dc.HtmlTag, Null, dc)
				Case $"<input type="email">"$
					Dim dc As HtmlElement = CreateHtmlElement("<input>", Array(CreateHtmlAttribute("type", "email"), CreateHtmlAttribute("id", "email"), CreateHtmlAttribute("class", "form-control")), "")
					Tree.AddItem(div2, dc.HtmlTag, Null, dc)
				Case $"<input type="password">"$
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case $"<input type="date">"$
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case $"<button>"$
					Dim dc As HtmlElement = CreateHtmlElement("<button>", Array(CreateHtmlAttribute("type", "button"), CreateHtmlAttribute("id", "button1"), CreateHtmlAttribute("class", "btn btn-primary")), "Button1")
					Tree.AddItem(div2, dc.HtmlTag, Null, dc)
				Case "<select>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case "<table>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case "<th>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case "<tbody>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case "<tr>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case "<td>"
					xui.MsgboxAsync("View not yet implemented", "Demo")
				Case Else
					xui.MsgboxAsync("View not yet implemented", "Demo")
			End Select
	End Select
End Sub

Private Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Tree.CLV_VisibleRangeChanged(FirstIndex, LastIndex)
End Sub

Private Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	Dim item As CLVTreeItem = Value
	'Log(item.Text)
	'Log(item.Tag)
	Dim Data As Map = CreateMap()
	Dim element As HtmlElement = item.Tag
	PD1.Initialize(PnlProperties, element.HtmlTag, PnlProperties.Width, PnlProperties.Height)
	PD1.AddSeparator("Main")
	If element.Content.Length > 0 Then
		PD1.AddTextItem("Text", "Text")
		Data.Put("Text", element.Content)
	End If
	PD1.AddSeparator("Attributes")
	If element.Attributes.IsInitialized Then
		Dim AttributeList As List = element.Attributes
		'Log(AttributeList)
		Dim Data As Map = CreateMap()
		For Each AttributeItem As HtmlAttribute In AttributeList
			'Log(AttributeItem)
			PD1.AddTextItem(AttributeItem.Name, AttributeItem.Name)
			Data.Put(AttributeItem.Name, AttributeItem.Value)
		Next
	End If
	'PD1.AddBooleanItem("Key1", "True/False")
	Wait For (PD1.ShowDialog(Data, "OK", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Log("ok")
	End If
End Sub

Sub WebView1_PageFinished (Url As String)
	'txtUrl.Text = Url
End Sub

Sub lstHistory_SelectedIndexChanged(Index As Int)
	If Index = -1 Then Return
	'txtUrl.Text = lstHistory.Items.Get(Index)
	'lstHistory.SelectedIndex = -1
	'btnGo_Action
End Sub

Private Sub btnCollapseAll_Click
	Tree.CollapseAll
End Sub

Private Sub btnExpandAll_Click
	Tree.ExpandAll
End Sub

Sub WebViewAssetFile (FileName As String) As String
   #if B4J
	Return File.GetUri(File.DirAssets, FileName)
   #Else If B4A
     Dim jo As JavaObject
     jo.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
     If jo.GetField("virtualAssetsFolder") = Null Then
       Return "file:///android_asset/" & FileName.ToLowerCase
     Else
       Return "file://" & File.Combine(jo.GetField("virtualAssetsFolder"), _
       jo.RunMethod("getUnpackedVirtualAssetFile", Array As Object(FileName)))
     End If
   #Else If B4i
     Return $"file://${File.Combine(File.DirAssets, FileName)}"$
   #End If
End Sub

Public Sub CreateHtmlAttribute (Name As String, Value As Object) As HtmlAttribute
	Dim t1 As HtmlAttribute
	t1.Initialize
	t1.Name = Name
	t1.Value = Value
	Return t1
End Sub

Public Sub CreateHtmlElement (HtmlTag As Object, Attributes As List, Content As String) As HtmlElement
	Dim t1 As HtmlElement
	t1.Initialize
	t1.HtmlTag = HtmlTag
	t1.Attributes = Attributes
	t1.Content = Content
	Return t1
End Sub